@CLS
@echo off
@echo.
@echo #########################
@echo ### Adp check START!! ###
@echo #########################

set /a N=0

:LOOP
MegaCli -AdpAllInfo -a%N% > tmp%N%.log

:NOADP
find "Failed to get CpController object." tmp%N%.log > Nul
if errorlevel 1 goto CHECK
goto EXIT

:CHECK
find "-0589" tmp%N%.log > Nul
if errorlevel 1 goto TARGET
goto ALREADY

:ALREADY
@echo Adapter %N%: Already updated!!! >> CHECK.txt
goto SET

:TARGET
find "FW Version         : 1.12" tmp%N%.log > Nul
if errorlevel 1 goto NOT
 
@echo Adapter %N%: Target adapter!!! >> CHECK.txt
goto SET

:NOT
@echo Adapter %N%: Not target adapter!!! >> CHECK.txt
goto SET

:SET
set /a N=N+1
goto LOOP

:EXIT
CLS
@echo ### Adp Check Results ###
@echo.
Type CHECK.txt
@echo.

pause

DEL CHECK.txt > nul
DEL tmp0.log > nul
DEL tmp1.log > nul
DEL tmp2.log > nul
DEL tmp3.log > nul

@CLS
@echo off
@echo.
@echo ########################
@echo ### PR check START!! ###
@echo ########################

set /a N=0

:LOOP1
MegaCli -AdpAllInfo -a%N% > tmp%N%.log

:NOADP1
find "Failed to get CpController object." tmp%N%.log > Nul
if errorlevel 1 goto CHECK1
goto EXIT1

:CHECK1
find "FW Version         : 1.12" tmp%N%.log > Nul
if errorlevel 1 goto NOT1
goto TARGET1

:NOT1
@echo Adapter %N%: Not target adapter!!! >> PRCHECK.txt
goto SET1

:TARGET1
MegaCli -AdpPR -Info -a%N% > pr%N%.log
find "Patrol Read Execution Delay: 228 hours" pr%N%.log > Nul
if errorlevel 1 goto PR1

@echo Adapter %N%: Already set!!! >> PRCHECK.txt
goto SET1

:PR1
@echo Adapter %N%: Target adapter!!! >> PRCHECK.txt
goto SET1

:SET1
set /a N=N+1
goto LOOP1

:EXIT1
CLS
@echo ### PR Check Results ###
@echo.
Type PRCHECK.txt
@echo.

pause

DEL PRCHECK.txt > nul
DEL tmp0.log > nul
DEL tmp1.log > nul
DEL tmp2.log > nul
DEL tmp3.log > nul
DEL pr0.log > nul
DEL pr1.log > nul
DEL pr2.log > nul
DEL pr3.log > nul
DEL CmdTool.log > nul
DEL MegaSAS.log > nul