@CLS
@echo off
@echo.
@echo #########################
@echo ### FW Update START!! ###
@echo #########################

set /a N=0
:LOOP
MegaCli -AdpAllInfo -a%N% > tmp%N%.log

:NOADP
find "Failed to get CpController object." tmp%N%.log > Nul
if errorlevel 1 goto CHECK
goto EXIT

:CHECK
find "-0589" tmp%N%.log > Nul
if errorlevel 1 goto TARGET
goto ALREADY

:ALREADY
MegaCli -AdpPR -enblman -a%N%
if errorlevel 1 goto PRNG
MegaCli -AdpPR -stop -a%N%
if errorlevel 1 goto PRNG
MegaCli -AdpPR -setdelay 228 -a%N%
if errorlevel 1 goto PRNG
MegaCli -AdpPR -enblauto -a%N%
if errorlevel 1 goto PRNG
@echo Adapter %N%: Set PR COMPLETED!!! >> RESULT.txt
goto SET

:TARGET
find "FW Version         : 1.12" tmp%N%.log > Nul
if errorlevel 1 goto NOT

MegaCli -AdpFwFlash -f FW.rom -NoSigChk -NoVerChk -a%N%
if errorlevel 1 goto NG
@echo Adapter %N%: FW Update COMPLETED!!! >> RESULT.txt

MegaCli -AdpPR -enblman -a%N%
if errorlevel 1 goto PRNG
MegaCli -AdpPR -stop -a%N%
if errorlevel 1 goto PRNG
MegaCli -AdpPR -setdelay 228 -a%N%
if errorlevel 1 goto PRNG
MegaCli -AdpPR -enblauto -a%N%
if errorlevel 1 goto PRNG
@echo Adapter %N%: Set PR COMPLETED!!! >> RESULT.txt
goto SET

:NOT
@echo Adapter %N%: Not target adapter!!! >> RESULT.txt
goto SET

:NG
@echo Adapter %N%: FW Update Failed >> RESULT.txt

:PRNG
@echo Adapter %N%: Set PR Failed!!! >> RESULT.txt

goto EXIT

:SET
set /a N=N+1
goto LOOP

:EXIT
CLS
@echo ### FW Update Results ###
@echo.
Type RESULT.txt
@echo.

pause

DEL RESULT.txt > nul
DEL tmp0.log > nul
DEL tmp1.log > nul
DEL tmp2.log > nul
DEL tmp3.log > nul
DEL CmdTool.log > nul
DEL MegaSAS.log > nul